#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red

extern bool Alerts = TRUE;
extern bool Tunnel_Alerts = FALSE;
extern bool Email_Alerts = FALSE;
double Buf0[];
double Buf1[];
double Buf2[];
double Buf3[];
bool gi_104 = FALSE;
bool gi_108 = FALSE;
bool gi_unused_112 = FALSE;
extern int FasterLWMA = 2;
extern int SlowerLWMA = 8;
extern int FasterSidusEMA = 18;
extern int SlowerSidusEMA = 28;
int gi_132 = 0;
int gi_136 = 0;

int init() {
   SetIndexStyle(0, DRAW_ARROW, EMPTY,2);
   SetIndexArrow(0, SYMBOL_ARROWUP);
   SetIndexBuffer(0, Buf0);
   SetIndexStyle(1, DRAW_ARROW, EMPTY,2);
   SetIndexArrow(1, SYMBOL_ARROWDOWN);
   SetIndexBuffer(1, Buf1);
   SetIndexStyle(2, DRAW_ARROW, EMPTY,3);
   SetIndexArrow(2, SYMBOL_STOPSIGN);
   SetIndexBuffer(2, Buf2);
   SetIndexStyle(3, DRAW_ARROW, EMPTY,3);
   SetIndexArrow(3, SYMBOL_STOPSIGN);
   SetIndexBuffer(3, Buf3);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_8;
   double l_irsi_12;
   double l_irsi_20;
   double l_icci_28;
   double l_ima_36;
   double l_ima_44;
   double l_ima_52;
   double l_ima_60;
   double l_ima_68;
   double l_ima_76;
   double l_ima_84;
   double l_ima_92;
   double l_ima_100;
   double l_ima_108;
   double l_ima_116;
   double l_ima_124;
   double ld_132;
   double ld_140;
   int li_148 = IndicatorCounted();
   if (li_148 < 0) return (-1);
   if (li_148 > 0) li_148--;
   int li_0 = Bars - li_148;
   for (int i = 0; i <= li_0; i++) {
      li_8 = i;
      ld_132 = 0;
      ld_140 = 0;
      for (li_8 = i; li_8 <= i + 9; li_8++) ld_140 += MathAbs(High[li_8] - Low[li_8]);
      ld_132 = ld_140 / 10.0;
      l_ima_36 = iMA(NULL, 0, FasterLWMA, 0, MODE_LWMA, PRICE_CLOSE, i);
      l_ima_52 = iMA(NULL, 0, FasterLWMA, 0, MODE_LWMA, PRICE_CLOSE, i + 1);
      l_ima_68 = iMA(NULL, 0, SlowerLWMA, 0, MODE_LWMA, PRICE_CLOSE, i - 1);
      l_ima_44 = iMA(NULL, 0, SlowerLWMA, 0, MODE_LWMA, PRICE_CLOSE, i);
      l_ima_60 = iMA(NULL, 0, SlowerLWMA, 0, MODE_LWMA, PRICE_CLOSE, i + 1);
      l_ima_76 = iMA(NULL, 0, SlowerLWMA, 0, FasterLWMA, PRICE_CLOSE, i - 1);
      l_ima_84 = iMA(NULL, 0, FasterSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i);
      l_ima_92 = iMA(NULL, 0, FasterSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i + 1);
      l_ima_100 = iMA(NULL, 0, FasterSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i - 1);
      l_ima_108 = iMA(NULL, 0, SlowerSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i);
      l_ima_116 = iMA(NULL, 0, SlowerSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i + 1);
      l_ima_124 = iMA(NULL, 0, SlowerSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i - 1);
      l_irsi_12 = iRSI(NULL, 0, 21, PRICE_CLOSE, i);
      l_irsi_20 = iRSI(NULL, 0, 21, PRICE_CLOSE, i + 1);
      l_icci_28 = iCCI(NULL, 0, 50, PRICE_CLOSE, i);
      if (l_ima_84 > l_ima_108 && l_ima_92 <= l_ima_116 && l_ima_100 > l_ima_124) {
         gi_108 = TRUE;
         gi_104 = FALSE;
         Buf2[i] = Low[i] - 1.0 * ld_132;
         if (i <= 2 && Alerts && !gi_132 && Tunnel_Alerts) {
            gi_132 = TRUE;
            gi_136 = FALSE;
            Alert(Symbol(), " ", Period(), "M  Tunnel UP ");
            if (Email_Alerts) SendMail("Tunnel UP " + Symbol(), "");
         }
      }
      if (l_ima_84 < l_ima_108 && l_ima_92 >= l_ima_116 && l_ima_100 < l_ima_124) {
         gi_104 = TRUE;
         gi_108 = FALSE;
         Buf3[i] = High[i] + 1.2 * ld_132;
         if (i <= 2 && Alerts && !gi_136 && Tunnel_Alerts) {
            gi_132 = FALSE;
            gi_136 = TRUE;
            Alert(Symbol(), " ", Period(), "M Tunnel DOWN ");
            if (Email_Alerts) SendMail(" Tunnel DOWN " + Symbol(), "");
         }
      }
      if ((l_ima_36 > l_ima_84 && l_ima_36 > l_ima_108) || (l_ima_44 > l_ima_84 && l_ima_44 > l_ima_108) && l_ima_52 <= l_ima_92 || l_ima_52 <= l_ima_116 && l_ima_60 <= l_ima_92 ||
         l_ima_60 <= l_ima_116 && gi_108) {
         gi_108 = FALSE;
         gi_104 = FALSE;
         gi_unused_112 = TRUE;
         Buf0[i] = Low[i] - 1.6 * ld_132;
         if (i <= 2 && Alerts && !gi_132) {
            Alert("Arbalet BUY ("+Symbol()+","+fTimeFrameName(Period())+"): Bid="+DS(Bid));
            if (Email_Alerts) SendMail("Arbalet BUY " + Symbol(), "");
            gi_132 = TRUE;
            gi_136 = FALSE;
         }
      }
      if ((l_ima_36 < l_ima_84 && l_ima_36 < l_ima_108) || (l_ima_44 < l_ima_84 && l_ima_44 < l_ima_108) && l_ima_52 >= l_ima_92 || l_ima_52 >= l_ima_116 && l_ima_60 >= l_ima_92 ||
         l_ima_60 >= l_ima_116 && gi_104) {
         gi_108 = FALSE;
         gi_104 = FALSE;
         gi_unused_112 = TRUE;
         Buf1[i] = High[i] + 1.2 * ld_132;
         if (i <= 2 && Alerts && !gi_136) {
            Alert("Arbalet SELL ("+Symbol()+","+fTimeFrameName(Period())+"): Bid="+DS(Bid));
            if (Email_Alerts) SendMail("Arbalet SELL " + Symbol(), "");
            gi_136 = TRUE;
            gi_132 = FALSE;
         }
      }
   }
   return (0);
}
//+------------------------------------------------------------------+

string DS(double v){return(DoubleToStr(v, Digits));}

string fTimeFrameName(int arg){

   // fTimeFrameName();

   int v;
      if(arg==0){
         v=Period();
      }
      else{
         v=arg;
      }
      switch(v){
         case 0:
            return("0");
         case 1:
            return("M1");
         case 5:
            return("M5");                  
         case 15:
            return("M15");
         case 30:
            return("M30");             
         case 60:
            return("H1");
         case 240:
            return("H4");                  
         case 1440:
            return("D1");
         case 10080:
            return("W1");          
         case 43200:
            return("MN1");
         default:
            return("Wrong TimeFrame");          
      }
}

